function enableBadge(badgeElement)
{
    var badgesList = document.getElementById(badgeElement).getElementsByTagName("span");
    for (i = 0; i < badgesList.length; i++)
    {
        badgesList[i].classList.add("badge-warning");
        badgesList[i].classList.remove("text-muted");
        badgesList[i].classList.remove("badge-light");
    }
}

function disableBadge(badgeElement)
{
    var badgesList = document.getElementById(badgeElement).getElementsByTagName("span");
    for (i = 0; i < badgesList.length; i++)
    {
        badgesList[i].classList.remove("badge-warning");
        badgesList[i].classList.add("text-muted");
        badgesList[i].classList.add("badge-light");
    }
}


function sortAlphabetically(selectName)
{
        var functionsToSort = $(selectName + ' ' + 'option');
        functionsToSort.sort(function(a,b){
           var textA = a.text.toUpperCase();
           var textB = b.text.toUpperCase();
           return (textA < textB) ? -1 : (textA > textB) ? 1 : 0;
        });
        $(selectName).html(functionsToSort);
}

/**
* Add error msg to modal (remove existing messages first
*/
function addAlertToModal(alerts, msg)
{
    removeAllAlerts(alerts);
    var alert = document.createElement("div");
    var msg   = document.createTextNode(msg);
    alert.className = "alert alert-danger";
    //alert.role = "alert";
    alert.appendChild(msg);
    alerts.appendChild(alert);
}

function removeAllAlerts(alerts)
{
    while (alerts.hasChildNodes()) {
      alerts.removeChild(alerts.lastChild);
    }
}

/*
* Populate Edit lowercase list modal
*/
$('#capitalizerLowercaseModal').on('show.bs.modal', function (e) {

 updateFreeTextModal("capitalizerLowercase");
});

/*
* Save changes made in modal to display
*/
function capitalizerLowercaseSave()
{
    saveFreeTextList("capitalizerLowercase");
}

/*
* Populate Edit uppercase list modal
*/
$('#capitalizerUppercaseModal').on('show.bs.modal', function (e) {
 updateFreeTextModal("capitalizerUppercase");
});


/*
* Save changes made in modal to display
*/
function capitalizerUppercaseSave()
{
    saveFreeTextList("capitalizerUppercase");
}

/*
* Populate Edit keepasis list modal
*/
$('#capitalizerKeepModal').on('show.bs.modal', function (e) {
    updateFreeTextModal("capitalizerKeep");
});

function capitalizerKeepSave()
{
   saveFreeTextList("capitalizerKeep");
}

function updateFreeTextModal(userOption)
{
    var badges = document.getElementById(userOption + "Span").querySelectorAll(".badge");
    var words  = "";
    for (var i = 0, len = badges.length; i < len; i++) {
      words+=(badges[i].innerText) + "\n";
    }
    document.getElementById(userOption).value = words;
    removeAllAlerts(document.getElementById(userOption + "ModalAlerts"));
}

function saveFreeTextList(userOption)
{
   var modifiedValue   = document.getElementById(userOption).value;
   var displayValue    = document.getElementById(userOption + "Span");
   var hiddenValue     = document.getElementById(userOption + "Hidden");
   var words = modifiedValue.split("\n");

   var hidden = "";
   displayValue.innerHTML="";
   for (var i = 0, len = words.length; i < len; i++) {
       if(words[i].length>0)
       {
           var span=document.createElement("span");
           span.innerHTML=words[i];
           span.className = ' badge badge-warning ml-1';
           displayValue.appendChild(span);
           hidden+=words[i];
           hidden+=",";
       }
   }
    hiddenValue.value=hidden;
}


$('#fieldsCapitalizerModal').on('show.bs.modal', function (e) {
    initFieldsModal("fieldsCapitalizer");
});


$('#fieldsFindAndReplaceModal').on('show.bs.modal', function (e) {
    initFieldsModal("fieldsCapitalizer");
});


$('#fieldsTrimModal').on('show.bs.modal', function (e) {
    initFieldsModal("fieldsTrim");
});
