/*
* Delete Rename Mask,
* Informs server of the mask to delete, if it manages it ok then we remove locally from the html
* TODO internationalize error messages
*/
function deleteRenameMask()
{
    var selectMask = document.getElementById("filenamemasks");
    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.delete_rename_mask', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(selectMask.options[document.getElementById("filenamemasks").selectedIndex].text);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                var index = selectMask.selectedIndex;
                selectMask.remove(index);
            }
            else
            {
               alert(xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Add new Rename Mask, make request to server to actually add new mask
* TODO add in right place instead of end.
*/
function addRenameMask()
{
    var selectMask = document.getElementById("filenamemasks");

    var maskName = document.getElementById("add_filename_mask_name").value;
    var maskMask = document.getElementById("add_filename_mask_mask").value;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.add_rename_mask', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(maskName+":"+maskMask);

    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                document.getElementById("add_filename_mask_name").value = "";
                document.getElementById("add_filename_mask_mask").value = "";
                $('#addmodal').modal('hide')

                var newmask = document.createElement("option");
                newmask.text  = maskName;
                newmask.value = maskMask;
                selectMask.add(newmask);
            }
            else
            {
                addAlertToModal(document.getElementById("addmodalAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Modify Rename Mask, make request to server to actually rename
*/
function editRenameMask()
{
    var selectMask = document.getElementById("filenamemasks");
    var maskName = document.getElementById("edit_filename_mask_name").value;
    var maskMask = document.getElementById("edit_filename_mask_mask").value;
    var index = selectMask.selectedIndex;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.edit_rename_mask', true);
    xhr.setRequestHeader("Content-type", "text/plain");

    var origMaskName = selectMask.options[selectMask.selectedIndex].text;

    xhr.send(origMaskName+":"+maskName+":"+maskMask);

    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                document.getElementById("edit_filename_mask_name").value = "";
                document.getElementById("edit_filename_mask_mask").value = "";
                $('#editmodal').modal('hide')

                selectMask[index].text = maskName;
                selectMask[index].value = maskMask;
            }
            else
            {
                addAlertToModal(document.getElementById("editmodalAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}


/**
* Add new Rename Mask, make request to server to actually add new mask
* TODO add in right place instead of end.
*/
function cloneRenameMask()
{
    var selectMask = document.getElementById("filenamemasks");

    var maskName = document.getElementById("clone_filename_mask_name").value;
    var maskMask = document.getElementById("clone_filename_mask_mask").value;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.add_rename_mask', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(maskName+":"+maskMask);

    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                document.getElementById("clone_filename_mask_name").value = "";
                document.getElementById("clone_filename_mask_mask").value = "";
                $('#clonemodal').modal('hide')

                var newmask = document.createElement("option");
                newmask.text  = maskName;
                newmask.value = maskMask;
                selectMask.add(newmask);
            }
            else
            {
                addAlertToModal(document.getElementById("clonemodalAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}

/*
Add scriptvar to mask being edited
*/
function addToEditMask(select, mask)
{
    var selectedValue = document.getElementById(select).value;
    var scriptvar     = selectedValue.substring(0, selectedValue.indexOf("("));
    if(document.getElementById(mask).value.length==0)
    {
        document.getElementById(mask).value+=scriptvar;
    }
    else
    {
        document.getElementById(mask).value+=" + "+scriptvar;
    }
}

/*
* Update Rename mask
*/
function updateExampleMask(maskValue, exampleField, alertsField)
{
  var xhr = new XMLHttpRequest();
  xhr.open('POST', '/renamefiles.example_mask', true);
  xhr.send(maskValue);
        xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText.startsWith('ok'))
            {
               exampleField.innerHTML=xhr.responseText.substring(3);
            }
            else
            {
               addAlertToModal(alertsField, xhr.responseText.substring(6));
            }
        }
     };
}
/*
* Populate Edit Mask Dialog with value currently selected in combo
*/
$('#editmodal').on('show.bs.modal', function (e) {
  var opt = document.getElementById("filenamemasks").options[document.getElementById("filenamemasks").selectedIndex];
  document.getElementById("edit_filename_mask_name").value = opt.text
  document.getElementById("edit_filename_mask_mask").value = opt.value.trim();
  removeAllAlerts(document.getElementById("editmodalAlerts"));
  updateExampleMask(document.getElementById("edit_filename_mask_mask").value, document.getElementById("editmodalexample"), document.getElementById("editmodalAlerts"));
});

/*
* Populate Clone Filename Mask Dialog with value currently selected in combo
*/
$('#clonemodal').on('show.bs.modal', function (e) {
  var opt = document.getElementById("filenamemasks").options[document.getElementById("filenamemasks").selectedIndex];
  document.getElementById("clone_filename_mask_name").value = opt.text + ' Clone'
  document.getElementById("clone_filename_mask_mask").value = opt.value.trim();
  removeAllAlerts(document.getElementById("clonemodalAlerts"));
  updateExampleMask(document.getElementById("clone_filename_mask_mask").value, document.getElementById("clonemodalexample"), document.getElementById("clonemodalAlerts"));
});

/** Update example mask whenever mods made to edit filename mask */
$('#edit_filename_mask_mask').focusout(function(){
    updateExampleMask(document.getElementById("edit_filename_mask_mask").value, document.getElementById("editmodalexample"), document.getElementById("editmodalAlerts"));
});

/** Update example mask whenever mods made to clone filename mask */
$('#clone_filename_mask_mask').focusout(function(){
    updateExampleMask(document.getElementById("clone_filename_mask_mask").value, document.getElementById("clonemodalexample"), document.getElementById("clonemodalAlerts"));
});

/** Update example mask whenever mods made to add filename mask */
$('#add_filename_mask_mask').focusout(function(){
    updateExampleMask(document.getElementById("add_filename_mask_mask").value, document.getElementById("addmodalexample"), document.getElementById("addmodalAlerts"));
});

/*
* Clear any alert messages from previous dialog
*/
$('#addmodal').on('show.bs.modal', function (e) {
  removeAllAlerts(document.getElementById("addmodalAlerts"));
});

/**
 * Delete selected Javascript Function, send request to server
 */
function deleteFunction()
{
    var functions = document.getElementById("javascriptFunctions");
    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.delete_function', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(functions.options[functions.selectedIndex].text);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                var index = functions.selectedIndex;
                functions.remove(index);
            }
            else
            {
                alert(xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Add new Javascript Function, after user has created fucntion in UI make request to server to actually add it.

* TODO add in right place instead of end.
*/
function addFunction()
{
    var functions           = document.getElementById("javascriptFunctions");
    var editMaskFunctions   = document.getElementById("editMaskJavascriptList");
    var addMaskFunctions    = document.getElementById("addMaskJavascriptList");

    var javascriptFunction  = document.getElementById("add_function").value;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.add_function', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(javascriptFunction);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText.startsWith('ok:'))
            {
                document.getElementById("add_function").value = "";
                $('#addModalFunction').modal('hide');

                var newFunction = document.createElement("option");
                newFunction.text  = xhr.responseText.substring(3);
                newFunction.value = javascriptFunction;
                functions.add(newFunction);
                sortAlphabetically("#javascriptFunctions");

                var newFunctionName = document.createElement("option");
                newFunctionName.text  = xhr.responseText.substring(3);
                newFunctionName.value = xhr.responseText.substring(3);
                addMaskFunctions.add(newFunctionName);
                sortAlphabetically("#addMaskJavascriptList");

                var newFunctionNameEdit = document.createElement("option");
                newFunctionNameEdit.text  = xhr.responseText.substring(3);
                newFunctionNameEdit.value = xhr.responseText.substring(3);
                editMaskFunctions.add(newFunctionNameEdit);
                sortAlphabetically("#editMaskJavascriptList");

            }
            else
            {
                addAlertToModal(document.getElementById("addModalFunctionAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Sort contents of select alphabetically
*/
function sortAlphabetically(selectName)
{
        var functionsToSort = $(selectName + ' ' + 'option');
        functionsToSort.sort(function(a,b){
           var textA = a.text.toUpperCase();
           var textB = b.text.toUpperCase();
           return (textA < textB) ? -1 : (textA > textB) ? 1 : 0;
        });
        $(selectName).html(functionsToSort);
}
/**
* Add error msg to modal (remove existing messages first
*/
function addAlertToModal(alerts, msg)
{
    removeAllAlerts(alerts);
    var alert = document.createElement("div");
    var msg   = document.createTextNode(msg);
    alert.className = "alert alert-danger";
    //alert.role = "alert";
    alert.appendChild(msg);
    alerts.appendChild(alert);
}

function removeAllAlerts(alerts)
{
    while (alerts.hasChildNodes()) {
      alerts.removeChild(alerts.lastChild);
    }
}

/**
* Edit Javascript Function, after user has edited in UI send request to server
* TODO Reorder
*/
function editFunction()
{
   var functions           = document.getElementById("javascriptFunctions");
   var editMaskFunctions   = document.getElementById("editMaskJavascriptList");
   var addMaskFunctions    = document.getElementById("addMaskJavascriptList");
   var javascriptFunction  = document.getElementById("edit_function").value;
   var origFunctionName    = functions.options[functions.selectedIndex].text;
   var index = functions.selectedIndex;

   var xhr = new XMLHttpRequest();
   xhr.open('POST', '/preferences.edit_function', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send(origFunctionName+":"+javascriptFunction);
   xhr.onreadystatechange = function() {
       if (this.readyState == 4 && this.status == 200)
       {
           if(xhr.responseText.startsWith('ok:'))
           {
               document.getElementById("edit_function").value = "";
               $('#editModalFunction').modal('hide')

               functions[index].text  = xhr.responseText.substring(3)
               functions[index].value = javascriptFunction;
               sortAlphabetically("#javascriptFunctions");

               editMaskFunctions[index].text  = xhr.responseText.substring(3)
               editMaskFunctions[index].value = xhr.responseText.substring(3)
               sortAlphabetically("#editMaskJavascriptList");

               addMaskFunctions[index].text   = xhr.responseText.substring(3)
               addMaskFunctions[index].value  = xhr.responseText.substring(3)
               sortAlphabetically("#addMaskJavascriptList");
           }
           else
           {
               addAlertToModal(document.getElementById("editModalFunctionAlerts"),xhr.responseText.substring(6));
           }
       }
   };
}

/*
* Populate Edit Javascript function with value currently selected in combo
*/
$('#editModalFunction').on('show.bs.modal', function (e) {
  var opt = document.getElementById("javascriptFunctions").options[document.getElementById("javascriptFunctions").selectedIndex];
  document.getElementById("edit_function").value = opt.value;
  removeAllAlerts(document.getElementById("editModalFunctionAlerts"));
});

//editmodal

/*
* Clear any alert messages from previous dialog
*/
$('#addModalFunction').on('show.bs.modal', function (e) {
  removeAllAlerts(document.getElementById("addModalFunctionAlerts"));
});

/*
* Populate Rename Profile Dialog with profile currently selected in combo
*/
$('#renameprofilemodal').on('show.bs.modal', function (e) {
  var opt = document.getElementById("profiles").options[document.getElementById("profiles").selectedIndex];
  document.getElementById("rename_profile").value = opt.text;

  removeAllAlerts(document.getElementById("renameprofilemodalAlerts"));
});

/*
* Check Acoustid User Key
*/
function checkAcoustIdUserKey()
{
    var acoustidUserKey = document.getElementById("acoustidUserKey");

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.check_acoustid_user_key', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(acoustidUserKey.value);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            var code = xhr.responseText.substring(0,2);
            var msg  = xhr.responseText.substring(2);

            if(code.startsWith("1:"))
            {
                document.getElementById("acoustid_user_key_error").innerHTML = msg;
                document.getElementById("acoustid_user_key_error").style.color="red";
            }
            else
            {
                document.getElementById("acoustid_user_key_error").innerHTML = msg;
                document.getElementById("acoustid_user_key_error").style.color="green";
            }

        }
    };
}